package com.xiaoniu.subsystem.business.service.impl;

import com.alibaba.nacos.common.utils.CollectionUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xiaoniu.common.core.exception.ServiceException;
import com.xiaoniu.common.core.utils.StringUtils;
import com.xiaoniu.common.core.utils.bean.BeanValidators;
import com.xiaoniu.subsystem.business.domain.Flight;
import com.xiaoniu.subsystem.business.domain.Sign;
import com.xiaoniu.subsystem.business.domain.StudentInfo;
import com.xiaoniu.subsystem.business.domain.TeacherInfo;
import com.xiaoniu.subsystem.business.mapper.SignMapper;
import com.xiaoniu.subsystem.business.service.IFlightService;
import com.xiaoniu.subsystem.business.service.ISignService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xiaoniu.subsystem.business.service.IStudentInfoService;
import com.xiaoniu.subsystem.system.domain.Unit;
import com.xiaoniu.subsystem.system.service.IUnitService;
import jakarta.validation.Validator;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import static com.xiaoniu.common.security.utils.SecurityUtils.getUnitId;
import static com.xiaoniu.common.security.utils.SecurityUtils.getUserId;

/**
 * <p>
 * 签到表 服务实现类
 * </p>
 *
 * @author haoxuyang
 * @since 2024-12-23 05:36:11
 */
@Service
public class SignServiceImpl extends ServiceImpl<SignMapper, Sign> implements ISignService {
    protected final Validator validator;
    protected final IUnitService unitService;
    protected final IFlightService flightService;
    protected final IStudentInfoService studentInfoService;

    public SignServiceImpl(Validator validator, IUnitService unitService, IFlightService flightService, IStudentInfoService studentInfoService) {
        this.validator = validator;
        this.unitService = unitService;
        this.flightService = flightService;
        this.studentInfoService = studentInfoService;
    }

    @Override
    public String importData(List<Sign> list, boolean isUpdateSupport) {
        if (CollectionUtils.isEmpty(list)) {
            throw new ServiceException("导入签到数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        Map<String, Long> map = new HashMap<String, Long>();
        Map<String, Long> map1 = new HashMap<String, Long>();
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        Unit unit = unitService.getById(getUnitId());
        List<Unit> unitList = unitService.list();
        List<Unit> units =
                unitList.stream().filter(u -> StringUtils.equals("0", u.getType())).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(units)) {
            map.putAll(units.stream().collect(Collectors.toMap(Unit::getUnitName, Unit::getUnitId)));
        }
        List<Unit> units1 =
                unitList.stream().filter(u -> StringUtils.equals("1", u.getType())).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(units1)) {
            map1.putAll(units1.stream().collect(Collectors.toMap(Unit::getUnitName, Unit::getUnitId)));
        }
        for (Sign d : list) {
            try {
                //查询班次是否存在
                Flight flight = flightService.getOne(new LambdaQueryWrapper<Flight>()
                        .eq(Flight::getFlightName,d.getFlightName())
                        .eq(Flight::getYear,d.getYear())
                        .eq(Flight::getTrainingTime,d.getTrainingTime())
                );
                if (flight != null){
                    d.setFlightId(flight.getFlightId());
                    //根据班次id和学员名称获取学员信息
                    StudentInfo studentInfo = studentInfoService.getStudentInfoByFlightIdAndUserName(flight.getFlightId(), d.getUserName());
                    if(studentInfo != null){
                        d.setUserId(studentInfo.getStudentId());
                    }

                }
                // 验证是否存在这个数据
                Sign u = baseMapper.selectOne(new LambdaQueryWrapper<Sign>()
                        .eq(Sign::getUserName, d.getUserName())
                        .eq(Sign::getSignDate, d.getSignDate())
                        .eq(Sign::getFlightName,d.getFlightName())
                        .eq(Sign::getTrainingTime,d.getTrainingTime())
                        .eq(Sign::getYear,d.getYear())
                        );
                if (StringUtils.isNull(u) && d.getUserId() != null) {
                    BeanValidators.validateWithException(validator, d);
                    d.setCreateUser(getUserId());
                    d.setCreateDept(unit.getUnitId());
                    d.setCreateTime(new Date());
                    this.save(d);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、" + " 学员" + d.getUserName() + " 签到信息" + "导入成功");
                } else if (isUpdateSupport && d.getUserId() != null) {
                    BeanValidators.validateWithException(validator, d);
                    d.setUpdateUser(getUserId());
                    d.setUpdateTime(new Date());
                    this.updateById(d);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、" + " 学员 " + d.getUserName() + " 签到信息" + "更新成功");
                } else if (d.getUserId() == null) {
                    failureNum++;
                    failureMsg.append("<br/>" + failureNum + "、" + " 学员 " + d.getUserName()+ " 信息"  + "不存在");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>" + failureNum + "、" + " 学员 " + d.getUserName()+ " 签到信息"  + "已存在");
                }
            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、" + " 学员 " + d.getUserName()+ " 签到信息"  + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
}
